/*	$Id: hid.h,v 1.11 2008/05/28 09:40:35 tsubai Exp $	*/

/*-
 * Copyright (c) 2000 Tsubai Masanari.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef _POWERPC_HID_H_
#define _POWERPC_HID_H_

/* Hardware Implementation Dependent registers for the PowerPC */

/*
 *  HID0 bit definitions per cpu model
 *
 * bit	603	604	604e	750   7400/7410	7450
 *   0	EMCP	EMCP	EMCP	EMCP	EMCP	-
 *   1	-	ECPE	ECPE	DBP	-	-
 *   2	EBA	EBA	EBA	EBA	EBA	-
 *   3	EBD	EBD	EBD	EBD	EBD	-
 *   4	SBCLK	-	-	BCLK	BCKL	-
 *   5	EICE	-	-	-	-	TBEN
 *   6	ECLK	-	-	ECLK	ECLK	-
 *   7	PAR	PAR	PAR	PAR	PAR	STEN
 *   8	DOZE	-	-	DOZE	DOZE	-
 *   9	NAP	-	-	NAP	NAP	NAP
 *  10	SLEEP	-	-	SLEEP	SLEEP	SLEEP
 *  11	DPM	-	-	DPM	DPM	DPM
 *  12	RISEG	-	-	-	RISEG	-
 *  13	-	-	-	-	EIEC	BHTCLR
 *  14	-	-	-	-	-	XAEN
 *  15	-	NHR	NHR	NHR	NHR	NHR
 *  16	ICE	ICE	ICE	ICE	ICE	ICE
 *  17	DCE	DCE	DCE	DCE	DCE	DCE
 *  18	ILOCK	ILOCK	ILOCK	ILOCK	ILOCK	ILOCK
 *  19	DLOCK	DLOCK	DLOCK	DLOCK	DLOCK	DLOCK
 *  20	ICFI	ICFI	ICFI	ICFI	ICFI	ICFI
 *  21	DCFI	DCFI	DCFI	DCFI	DCFI	DCFI
 *  22	-	-	-	SPD	SPD	SPD
 *  23	-	-	IFEM	IFEM	IFTT	-
 *  24	-	SED	SED	SGE	SGE	SGE
 *  25	-	-	-	DCFA	DCFA	-
 *  26	-	-	-	BTIC	BTIC	BTIC
 *  27	FBIOB	-	-	-	-	LRSTK
 *  28	-	-	-	ABE	-	FOLD
 *  29	-	BHT	BHT	BHT	BHT	BHT
 *  30	-	-	BTACD	-	NOPDST	NOPDST
 *  31	NOOPTI	-	-	NOOPTI	NOPTI	NOPTI
 *
 *  604: SED = Serial instruction execution disable
 *  604: BTACD = BTAC disable
 *
 *
 *  HID1 bit definitions per cpu model
 *
 * bit	603e	604e	750   7400/7410	7450
 *   0	PC0	PC0	PC0	PC0	EMCP
 *   1	PC1	PC1	PC1	PC1
 *   2	PC2	PC2	PC2	PC2	EBA
 *   3	PC3	PC3	PC3	PC3	EBD
 *   4					BCLK
 *   5
 *   6					ECLK
 *   7					PAR
 *   8
 *  15					PC0
 *  16					PC1
 *  17					PC2
 *  18					PC3
 *  19
 *  20					SYNCBE
 *  21					ABE
 */

#endif /* _POWERPC_HID_H_ */
