/*	$Id: strlen.S,v 1.2 2006/01/02 16:29:57 tsubai Exp $	*/

/*-
 * Copyright (c) 2005 Tsubai Masanari.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <machine/asm.h>

/* SEE ALSO: arch/i386/string/strlen.S. */

ENTRY(strlen)
	rlwinm	4,3,0,0,29	/* r4 = r3 & ~3 */
	lis	5,0x0101
	ori	5,5,0x0101	/* r5 = 0x01010101 */
	slwi	6,5,7		/* r6 = 0x80808080 */

	lwz	7,0(4)
	rlwinm.	8,3,3,27,28	/* r8 = (r3 & 3) << 3 */
	beq	2f
	srw	9,5,8
	xor	9,9,5
	or	7,7,9
	b	2f

1:	lwzu	7,4(4)		/* x = r7 */
2:	sub	8,7,5		/* y = r8 */
	and.	8,8,6		/* (x - 0x01010101) & 0x80808080 */
3:	beq	1b

	/* Test false positive. */
	cntlzw	9,8		/* r9: bit position of non-zero part. */
	rlwnm.	0,7,9,0,7
	bne-	4f
	srwi	9,9,3
	add	4,4,9
	sub	3,4,3
	blr

4:	lis	0,0xff00
	srw	0,0,9
	andc.	8,8,0		/* y &= ~(0xff000000 >> r9) */
	b	3b
