/*	$NetBSD: asm.h,v 1.8 2001/06/13 06:01:48 simonb Exp $	*/

/*
 * Copyright (C) 1995, 1996 Wolfgang Solfrank.
 * Copyright (C) 1995, 1996 TooLs GmbH.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by TooLs GmbH.
 * 4. The name of TooLs GmbH may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY TOOLS GMBH ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL TOOLS GMBH BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef _POWERPC64_ASM_H_
#define _POWERPC64_ASM_H_

#ifdef __LP64__
#define _C_FUNC(x)	.x
#else
#define _C_FUNC(x)	x
#endif

#define _C_LABEL(x)	x
#define _ASM_LABEL(x)	x

#define _GLOBAL(x) \
	.data; .align 2; .globl x; x:

#define _ENTRY(x) \
	.text; .align 2; .globl x; .type x,@function; x:

#ifdef GPROF
# ifdef __LP64__
#  define _PROF_PROLOGUE	mflr 0; std 0,16(1); bl _mcount
# else
#  define _PROF_PROLOGUE	mflr 0; stw 0,4(1); bl _mcount
# endif
#else
# define _PROF_PROLOGUE
#endif

#define ENTRY(y)	_ENTRY(_C_FUNC(y)); _PROF_PROLOGUE
#define ENTRY_NOPROFILE(y) _ENTRY(_C_FUNC(y))
#define ASENTRY(y)	_ENTRY(_ASM_LABEL(y)); _PROF_PROLOGUE
#define GLOBAL(y)	_GLOBAL(_C_LABEL(y))

#ifdef __LP64__
#define FDESC(x) \
	.section ".opd","aw"; .align 3; .globl _C_LABEL(x); \
	_C_LABEL(x): .quad _C_FUNC(x),.TOC.@tocbase,0; .previous
#else
#define FDESC(x)
#endif

#define ASMSTR		.asciz

#define RCSID(x)	.text; .asciz x

#ifdef __ELF__
#define WEAK_ALIAS(alias,sym)					\
	.weak alias;						\
	alias = sym
#endif
#define STRONG_ALIAS(alias,sym)					\
	.globl alias;						\
	alias = sym

#ifdef __STDC__
#define WARN_REFERENCES(sym,msg)				\
	.pushsection .gnu.warning. ## sym ; .ascii msg ; .popsection
#else
#define WARN_REFERENCES(sym,msg)				\
	.pushsection .gnu.warning./**/sym ; .ascii msg ; .popsection
#endif /* __STDC__ */

#ifdef _KERNEL
#define GET_CPUINFO(r)	mfsprg	r,0
#endif

#endif /* _POWERPC64_ASM_H_ */
