/*	$Id: netbsd32_machdep.h,v 1.4 2007/09/17 09:05:57 tsubai Exp $	*/

/*-
 * Copyright (c) 2007 Tsubai Masanari.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef _POWERPC64_NETBSD32_MACHDEP_H_
#define _POWERPC64_NETBSD32_MACHDEP_H_

#include <sys/types.h>

#define NETBSD32_POINTER_TYPE u_int32_t
typedef struct { NETBSD32_POINTER_TYPE i32; } netbsd32_pointer_t;

/* powerpc has 32bit aligned 64bit integers */
#define NETBSD32_INT64_ALIGN __attribute__((__aligned__(4)))

typedef u_int32_t netbsd32_sigcontextp_t;

struct trapframe32 {
	int fixreg[32];
	int lr;
	int cr;
	int xer;
	int ctr;
	int srr0;
	int srr1;
	int dar;
	int dsisr;
	int exc;
};

struct netbsd32_sigcontext {
	int sc_onstack;
	int __sc_mask13;
	struct trapframe32 sc_frame;
	sigset_t sc_mask;
};

#if 0
#define NETBSD32_MD_IOCTL	/* enable netbsd32_md_ioctl() */
int netbsd32_md_ioctl(struct file *, netbsd32_u_long, void *, struct lwp *);
#endif

/*
 * When returning an off_t to userland, we need to modify the syscall
 * retval array.  We return a 64 bit value in r3 (high) and r4 (low)
 * for 32bit userland.
 */
#define NETBSD32_OFF_T_RETURN(rval)	\
	do {				\
		(rval)[1] = (rval)[0];	\
		(rval)[0] >>= 32;	\
	} while (0)

typedef unsigned int register32_t;

#endif /* _POWERPC64_NETBSD32_MACHDEP_H_ */
