/*	$Id: memset.S,v 1.2 2008/04/09 13:15:22 tsubai Exp $	*/

/*-
 * Copyright (c) 2005 Tsubai Masanari.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <machine/asm.h>

FDESC(bzero)
FDESC(memset)

ENTRY(bzero)	/* dst = r3, len = r4 */
	mr	5,4
	li	4,0
	/* FALLTHROUGH */

ENTRY(memset)	/* dst = r3(r6), val = r4, len = r5 */
	cmpdi	5,0		/* Return if len == 0. */
	beqlr

	rlwimi	4,4,8,16,23	/* val = 0000xyxy */
	rlwimi	4,4,16,0,15	/* val = xyxyxyxy */
	rldimi	4,4,32,0	/* val |= val << 32 */

	cmpldi	5,8		/* Special case if len <= 8. */
	bgt	1f
	mtxer	5
	mr	5,4
	stswx	4,0,3
	blr

1:	addi	6,3,-8
	andi.	7,6,7
	subfic	7,7,8
	std	4,8(6)
	add	6,6,7
	sub	5,5,7

	/* dst is aligned here. */
	srdi.	7,5,3		/* r7 = len >> 3 */
	beq	3f
	mtctr	7
2:	stdu	4,8(6)
	bdnz	2b

3:	andi.	7,5,7
	beqlr

	/* Fill trailing bytes. */
	stdx	4,7,6
	blr
