/*	$Id: strlen.S,v 1.1 2008/04/09 15:51:16 tsubai Exp $	*/

/*-
 * Copyright (c) 2005 Tsubai Masanari.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <machine/asm.h>

/* SEE ALSO: arch/i386/string/strlen.S. */

FDESC(strlen)

ENTRY(strlen)
	rldicr	4,3,0,60	/* r4 = r3 & ~7 */
	lis	5,0x0101
	ori	5,5,0x0101
	rldimi	5,5,32,0	/* r5 = 0x0101010101010101 */
	sldi	6,5,7		/* r6 = 0x8080808080808080 */

	ld	7,0(4)
	rldic.	8,3,3,58	/* r8 = (r3 & 7) << 3 */
	beq	2f
	srd	9,5,8
	xor	9,9,5
	or	7,7,9
	b	2f

1:	ldu	7,8(4)		/* x = r7 */
2:	sub	8,7,5		/* y = r8 */
	and.	8,8,6		/* (x - 0x010101...01) & 0x808080...80 */
3:	beq	1b

	/* Test false positive. */
	cntlzd	9,8		/* r9: bit position of non-zero part. */
	rldcr.	0,7,9,7
	bne-	4f
	srdi	9,9,3
	add	4,4,9
	sub	3,4,3
	blr

4:	lis	0,0xff00
	sldi	0,0,32
	srd	0,0,9
	andc.	8,8,0		/* y &= ~(0xff00000000000000 >> r9) */
	b	3b
