/*	$Id: atomic.S,v 1.7 2008/08/18 11:55:34 tsubai Exp $	*/

#include <machine/asm.h>

#ifdef _KERNEL
#define ALIAS(f, t) STRONG_ALIAS(f,t) 
#else
#define ALIAS(f, t) WEAK_ALIAS(f,t)
#endif

ENTRY_NOPROFILE(atomic_add_32)
1:	lwarx	5,0,3
	add	5,5,4
	stwcx.	5,0,3
	bne-	1b
	blr

ENTRY_NOPROFILE(atomic_add_32_nv)
1:	lwarx	5,0,3
	add	5,5,4
	stwcx.	5,0,3
	bne-	1b
	mr	3,5
	blr

ENTRY_NOPROFILE(atomic_inc_32)
1:	lwarx	4,0,3
	addi	4,4,1
	stwcx.	4,0,3
	bne-	1b
	blr

ENTRY_NOPROFILE(atomic_inc_32_nv)
1:	lwarx	4,0,3
	addi	4,4,1
	stwcx.	4,0,3
	bne-	1b
	mr	3,4
	blr

ENTRY_NOPROFILE(atomic_dec_32)
1:	lwarx	4,0,3
	addi	4,4,-1
	stwcx.	4,0,3
	bne-	1b
	blr

ENTRY_NOPROFILE(atomic_dec_32_nv)
1:	lwarx	4,0,3
	addi	4,4,-1
	stwcx.	4,0,3
	bne-	1b
	mr	3,4
	blr

ENTRY_NOPROFILE(atomic_and_32)
1:	lwarx	5,0,3
	and	5,5,4
	stwcx.	5,0,3
	bne-	1b
	blr

ENTRY_NOPROFILE(atomic_and_32_nv)
1:	lwarx	5,0,3
	and	5,5,4
	stwcx.	5,0,3
	bne-	1b
	mr	3,5
	blr

ENTRY_NOPROFILE(atomic_or_32)
1:	lwarx	5,0,3
	or	5,5,4
	stwcx.	5,0,3
	bne-	1b
	blr

ENTRY_NOPROFILE(atomic_or_32_nv)
1:	lwarx	5,0,3
	or	5,5,4
	stwcx.	5,0,3
	bne-	1b
	mr	3,5
	blr

ENTRY_NOPROFILE(atomic_swap_32)
1:	lwarx	5,0,3
	stwcx.	4,0,3
	bne-	1b
	mr	3,5
	blr

ENTRY_NOPROFILE(atomic_cas_32)
1:	lwarx	6,0,3
	cmpw	6,4
	bne-	2f
	stwcx.	5,0,3
	bne-	1b
	mr	3,6
	blr

2:	mr	3,6
	addi	4,1,-4
	stwcx.	4,0,4	/* clear reservation */
	blr

ENTRY_NOPROFILE(atomic_add_64)
1:	ldarx	5,0,3
	add	5,5,4
	stdcx.	5,0,3
	bne-	1b
	blr

ENTRY_NOPROFILE(atomic_add_64_nv)
1:	ldarx	5,0,3
	add	5,5,4
	stdcx.	5,0,3
	bne-	1b
	mr	3,5
	blr

ENTRY_NOPROFILE(atomic_inc_64)
1:	ldarx	4,0,3
	addi	4,4,1
	stdcx.	4,0,3
	bne-	1b
	blr

ENTRY_NOPROFILE(atomic_inc_64_nv)
1:	ldarx	4,0,3
	addi	4,4,1
	stdcx.	4,0,3
	bne-	1b
	mr	3,4
	blr

ENTRY_NOPROFILE(atomic_dec_64)
1:	ldarx	4,0,3
	addi	4,4,-1
	stdcx.	4,0,3
	bne-	1b
	blr

ENTRY_NOPROFILE(atomic_dec_64_nv)
1:	ldarx	4,0,3
	addi	4,4,-1
	stdcx.	4,0,3
	bne-	1b
	mr	3,4
	blr

ENTRY_NOPROFILE(atomic_and_64)
1:	ldarx	5,0,3
	and	5,5,4
	stdcx.	5,0,3
	bne-	1b
	blr

ENTRY_NOPROFILE(atomic_and_64_nv)
1:	ldarx	5,0,3
	and	5,5,4
	stdcx.	5,0,3
	bne-	1b
	mr	3,5
	blr

ENTRY_NOPROFILE(atomic_or_64)
1:	ldarx	5,0,3
	or	5,5,4
	stdcx.	5,0,3
	bne-	1b
	blr

ENTRY_NOPROFILE(atomic_or_64_nv)
1:	ldarx	5,0,3
	or	5,5,4
	stdcx.	5,0,3
	bne-	1b
	mr	3,5
	blr

ENTRY_NOPROFILE(atomic_swap_64)
1:	ldarx	5,0,3
	stdcx.	4,0,3
	bne-	1b
	mr	3,5
	blr

ENTRY_NOPROFILE(atomic_cas_64)
1:	ldarx	6,0,3
	cmpd	6,4
	bne-	2f
	stdcx.	5,0,3
	bne-	1b
	mr	3,6
	blr

2:	mr	3,6
	addi	4,1,-8
	stdcx.	4,0,4	/* clear reservation */
	blr

ENTRY_NOPROFILE(membar_consumer)
	isync
	blr

ENTRY_NOPROFILE(membar_producer)
	sync
	blr

#ifdef __LP64__

FDESC(atomic_add_32)
FDESC(atomic_add_32_nv)
FDESC(atomic_inc_32)
FDESC(atomic_inc_32_nv)
FDESC(atomic_dec_32)
FDESC(atomic_dec_32_nv)
FDESC(atomic_and_32)
FDESC(atomic_and_32_nv)
FDESC(atomic_or_32)
FDESC(atomic_or_32_nv)
FDESC(atomic_swap_32)
FDESC(atomic_cas_32)
FDESC(atomic_add_64)
FDESC(atomic_add_64_nv)
FDESC(atomic_inc_64)
FDESC(atomic_inc_64_nv)
FDESC(atomic_dec_64)
FDESC(atomic_dec_64_nv)
FDESC(atomic_and_64)
FDESC(atomic_and_64_nv)
FDESC(atomic_or_64)
FDESC(atomic_or_64_nv)
FDESC(atomic_swap_64)
FDESC(atomic_cas_64)
FDESC(membar_consumer)
FDESC(membar_producer)

ALIAS(atomic_add_int,atomic_add_32)
ALIAS(atomic_add_int_nv,atomic_add_32_nv)
ALIAS(atomic_inc_uint,atomic_inc_32)
ALIAS(atomic_inc_uint_nv,atomic_inc_32_nv)
ALIAS(atomic_dec_uint,atomic_dec_32)
ALIAS(atomic_dec_uint_nv,atomic_dec_32_nv)
ALIAS(atomic_and_uint,atomic_and_32)
ALIAS(atomic_and_uint_nv,atomic_and_32_nv)
ALIAS(atomic_or_uint,atomic_or_32)
ALIAS(atomic_or_uint_nv,atomic_or_32_nv)
ALIAS(atomic_swap_uint,atomic_swap_32)
ALIAS(atomic_cas_uint,atomic_cas_32)
ALIAS(atomic_add_long,atomic_add_64)
ALIAS(atomic_add_ptr,atomic_add_64)
ALIAS(atomic_add_long_nv,atomic_add_64_nv)
ALIAS(atomic_add_ptr_nv,atomic_add_64_nv)
ALIAS(atomic_inc_ulong,atomic_inc_64)
ALIAS(atomic_inc_ptr,atomic_inc_64)
ALIAS(atomic_inc_ulong_nv,atomic_inc_64_nv)
ALIAS(atomic_inc_ptr_nv,atomic_inc_64_nv)
ALIAS(atomic_dec_ulong,atomic_dec_64)
ALIAS(atomic_dec_ptr,atomic_dec_64)
ALIAS(atomic_dec_ulong_nv,atomic_dec_64_nv)
ALIAS(atomic_dec_ptr_nv,atomic_dec_64_nv)
ALIAS(atomic_and_ulong,atomic_and_64)
ALIAS(atomic_and_ulong_nv,atomic_and_64_nv)
ALIAS(atomic_or_ulong,atomic_or_64)
ALIAS(atomic_or_ulong_nv,atomic_or_64_nv)
ALIAS(atomic_swap_ulong,atomic_swap_64)
ALIAS(atomic_swap_ptr,atomic_swap_64)
ALIAS(atomic_cas_ulong,atomic_cas_64)
ALIAS(atomic_cas_ptr,atomic_cas_64)
ALIAS(membar_enter,membar_consumer)
ALIAS(membar_exit,membar_producer)
ALIAS(membar_sync,membar_producer)

#else

ALIAS(atomic_add_int,atomic_add_32)
ALIAS(atomic_add_long,atomic_add_32)
ALIAS(atomic_add_ptr,atomic_add_32)
ALIAS(atomic_add_int_nv,atomic_add_32_nv)
ALIAS(atomic_add_long_nv,atomic_add_32_nv)
ALIAS(atomic_add_ptr_nv,atomic_add_32_nv)
ALIAS(atomic_inc_uint,atomic_inc_32)
ALIAS(atomic_inc_ulong,atomic_inc_32)
ALIAS(atomic_inc_ptr,atomic_inc_32)
ALIAS(atomic_inc_uint_nv,atomic_inc_32_nv)
ALIAS(atomic_inc_ulong_nv,atomic_inc_32_nv)
ALIAS(atomic_inc_ptr_nv,atomic_inc_32_nv)
ALIAS(atomic_dec_uint,atomic_dec_32)
ALIAS(atomic_dec_ulong,atomic_dec_32)
ALIAS(atomic_dec_ptr,atomic_dec_32)
ALIAS(atomic_dec_uint_nv,atomic_dec_32_nv)
ALIAS(atomic_dec_ulong_nv,atomic_dec_32_nv)
ALIAS(atomic_dec_ptr_nv,atomic_dec_32_nv)
ALIAS(atomic_and_uint,atomic_and_32)
ALIAS(atomic_and_ulong,atomic_and_32)
ALIAS(atomic_and_uint_nv,atomic_and_32_nv)
ALIAS(atomic_and_ulong_nv,atomic_and_32_nv)
ALIAS(atomic_or_uint,atomic_or_32)
ALIAS(atomic_or_ulong,atomic_or_32)
ALIAS(atomic_or_uint_nv,atomic_or_32_nv)
ALIAS(atomic_or_ulong_nv,atomic_or_32_nv)
ALIAS(atomic_swap_uint,atomic_swap_32)
ALIAS(atomic_swap_ulong,atomic_swap_32)
ALIAS(atomic_swap_ptr,atomic_swap_32)
ALIAS(atomic_cas_uint,atomic_cas_32)
ALIAS(atomic_cas_ulong,atomic_cas_32)
ALIAS(atomic_cas_ptr,atomic_cas_32)
ALIAS(membar_enter,membar_consumer)
ALIAS(membar_exit,membar_producer)
ALIAS(membar_sync,membar_producer)

#endif
