/*	$NetBSD: setjmp.S,v 1.1 1998/01/27 15:13:12 sakamoto Exp $	*/
/*	from:	OpenBSD: setjmp.S,v 1.2 1996/12/28 06:22:18 rahnds Exp 	*/
/* kernel version of this file, does not have signal goop */
/* int setjmp(jmp_buf env) */

#include <machine/asm.h>

#define JMP_r1  0x08
#define JMP_r14 0x10
#define JMP_r15 0x18
#define JMP_r16 0x20
#define JMP_r17 0x28
#define JMP_r18 0x30
#define JMP_r19 0x38
#define JMP_r20 0x40
#define JMP_r21 0x48
#define JMP_r22 0x50
#define JMP_r23 0x58
#define JMP_r24 0x60
#define JMP_r25 0x68
#define JMP_r26 0x70
#define JMP_r27 0x78
#define JMP_r28 0x80
#define JMP_r29 0x88
#define JMP_r30 0x90
#define JMP_r31 0x98
#define JMP_lr  0xa0
#define JMP_cr  0xa8
#define JMP_ctr 0xb0
#define JMP_xer 0xb8
#define JMP_sig 0xc0

FDESC(setjmp)

ENTRY_NOPROFILE(setjmp)
	std	1,JMP_r1(3)
	std	14,JMP_r14(3)
	std	15,JMP_r15(3)
	std	16,JMP_r16(3)
	std	17,JMP_r17(3)
	std	18,JMP_r18(3)
	std	19,JMP_r19(3)
	std	20,JMP_r20(3)
	std	21,JMP_r21(3)
	std	22,JMP_r22(3)
	std	23,JMP_r23(3)
	std	24,JMP_r24(3)
	std	25,JMP_r25(3)
	std	26,JMP_r26(3)
	std	27,JMP_r27(3)
	std	28,JMP_r28(3)
	std	29,JMP_r29(3)
	std	30,JMP_r30(3)
	stw	31,JMP_r31(3)
	mfcr	0
	std	0,JMP_cr(3)
	mflr	0
	std	0,JMP_lr(3)
	mfctr	0
	std	0,JMP_ctr(3)
	mfxer	0
	std	0,JMP_xer(3)
	/* f14-f31, fpscr */
	li	3,0
	blr

FDESC(longjmp)

ENTRY_NOPROFILE(longjmp)
	ld	1,JMP_r1(3)
	ld	14,JMP_r14(3)
	ld	15,JMP_r15(3)
	ld	16,JMP_r16(3)
	ld	17,JMP_r17(3)
	ld	18,JMP_r18(3)
	ld	19,JMP_r19(3)
	ld	20,JMP_r20(3)
	ld	21,JMP_r21(3)
	ld	22,JMP_r22(3)
	ld	23,JMP_r23(3)
	ld	24,JMP_r24(3)
	ld	25,JMP_r25(3)
	ld	26,JMP_r26(3)
	ld	27,JMP_r27(3)
	ld	28,JMP_r28(3)
	ld	29,JMP_r29(3)
	ld	30,JMP_r30(3)
	ld	31,JMP_r31(3)
	ld	0,JMP_cr(3)
	mtcr	0
	ld	0,JMP_lr(3)
	mtlr	0
	ld	0,JMP_ctr(3)
	mtctr	0
	ld	0,JMP_xer(3)
	mtxer	0
	/* f14-f31, fpscr */
	mr	3,4
	blr
