/*	$Id: autoconf.h,v 1.6 2008/04/24 16:17:51 tsubai Exp $	*/

/*-
 * Copyright (c) 2006 Tsubai Masanari.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef _MACHINE_AUTOCONF_H_
#define _MACHINE_AUTOCONF_H_

struct confargs {
	char *ca_name;
#if 0
	long ca_bus_index;	/*  */
	long ca_dev_index;	/* 줬ɥ쥹ˤʤ */
#endif
	long ca_bus;		/* bus-id */
	long ca_dev;		/* dev-id */
	long ca_func;
	long ca_type;		/* dev-type */
	long ca_intr;		/* dev-intr */
	long ca_intrtype;

#if 0
	long ca_pcibus;		/* dev-pci_bus */
	long ca_pcidev;		/* dev-pci_dev */
	long ca_pcifunc;	/* dev-pci_fun */
#endif
};

int ps3_allocate_irq(void);
int ps3_connect_irq(u_long, u_long, u_long);
int ps3_connect_io_irq(u_long);
u_long ps3_allocate_dma_region(u_long, u_long, int);

void calc_delay __P((void));
void identifycpu __P((char *));
void *mapiodev __P((paddr_t, psize_t, int));

void ps3pic_init_irq(void);
void ps3pic_enable_irq(u_int);
void ps3pic_disable_irq(u_int);
int ps3pic_read_irq(void);
void ps3pic_eoi(u_int);

void init_interrupt __P((void));
void *intr_establish __P((int, int, int, int (*)(void *), void *));
void intr_disestablish __P((void *));
char *intr_typename __P((int));

int rsxfb_cnattach __P((void));

#endif /* _MACHINE_AUTOCONF_H_ */
