/*	$Id: hcalls.h,v 1.19 2011/10/20 12:14:52 tsubai Exp $	*/

/*-
 * Copyright (c) 2007 Tsubai Masanari.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/* 1 */
int HV_write_pte(long, long idx, long pte_hi, long pte_lo);

/* 2 */
int HV_construct_virtual_address_space(u_long minsz, u_long ps, u_long nps,
    u_long *vas_id, u_long *actual);

/* 7 */
int HV_select_virtual_address_space(int vas_id);

/* 9 */
int HV_pause(int);

/* 11 */
int HV_configure_irq_bitmap(u_long puid, u_long cpu, paddr_t pa);

/* 18 */
int HV_alloc_intrhand(int64_t *ihand);

/* 27 */
int HV_eoi(u_int irq);

/* 28 */
int HV_set_intrhand_irq(int irq, long ihand);

/* 31 */
int HV_notify_imask_change(long puid, long cpu);

/* 44 */
int HV_shutdown_lpar(int mode);

/* 69 */
int HV_get_pu_id(u_long *puid);

/* 74 */
int HV_get_lpar_id(u_int64_t *);

struct repository_value {
	u_int64_t value1;
	u_int64_t value2;
};

/* 91 */
int HV_read_repository(long lpar_id, long key1, long key2, long key3, long key4,
    struct repository_value *);

/* 120 */
int HV_alloc_intrhand_by_irq(int irq, int64_t *ihand);

/* 122 */
int HV_map_htab(long, u_int64_t *pa);

/* 170 */
int HV_open(long bus_id, long dev_id, long);

/* 171 */
int HV_close(long bus_id, long dev_id);

/* 172 */
int HV_map_device_mmio_region(long bus_id, long dev_id, u_long addr,
    u_long size, u_long pagesize, u_long *ret);

/* 174 */
int HV_alloc_device_dma_region(long bus_id, long dev_id, u_long len,
    u_long pagesize, u_long flags, u_long *dmabase);

/* 176 */
int HV_map_device_dma_region(long bus_id, long dev_id, paddr_t addr,
    u_long dmaaddr, psize_t size, u_long flags);

/* 197 */
int HV_set_device_intrhand(long bus_id, long dev_id, long ihand, long intr_id);

/* 232 */
int HV_read_rtc(u_int64_t *, u_int64_t *);

/* 162 */
int HV_read_vuart(int port, u_long addr, u_long len, u_int64_t *actlen);

/* 163 */
int HV_write_vuart(int port, u_long addr, u_long len, u_int64_t *actlen);

/* 164 */
int HV_set_vuart_param(int port, int param, u_int64_t value);

/* 165 */
int HV_get_vuart_param(int port, int param, u_int64_t *value);

/* 166 */
int HV_configure_vuart(paddr_t bitmap, u_int64_t *ihand);

/* 185 */
int HV_net_add_mcast(long bus_id, long dev_id, u_long addr, int);

/* 186 */
int HV_net_del_mcast(long bus_id, long dev_id, u_long addr, int);

/* 187 */
int HV_net_start_txdma(long bus_id, long dev_id, paddr_t, int);

/* 188 */
int HV_net_stop_txdma(long bus_id, long dev_id, int);

/* 189 */
int HV_net_start_rxdma(long bus_id, long dev_id, paddr_t, int);

/* 190 */
int HV_net_stop_rxdma(long bus_id, long dev_id, int);

/* 191 */
int HV_net_set_intrstatus_indicator(long bus_id, long dev_id, paddr_t, int);

/* 193 */
int HV_net_set_intrmask(long bus_id, long dev_id, u_long, int);

/* 194 */
int HV_net_control(long bus_id, long dev_id, u_long cmd, u_long param1,
    u_long param2, u_long param3, u_long *ret1, u_long *ret2);

/* 210 */
int HV_gpu_open(int);

/* 214 */
int HV_gpu_alloc_memory(u_long, u_long, u_long, u_long, u_long, u_long *,
    u_long *);

/* 217 */
int HV_gpu_alloc_context(u_long, u_long, u_long *, u_long *, u_long *,
    u_long *, u_long *);

/* 221 */
int HV_gpu_context_iomap(u_long, u_long, u_long, u_long, u_long);

/* 225 */
int HV_gpu_context_attribute(u_long, u_long, u_long, u_long, u_long, u_long);

/* 245 */
int HV_storage_read(u_long dev_id, u_long region, u_long block, u_long len,
    u_long, paddr_t addr, u_long *tag);

/* 246 */
int HV_storage_write(u_long dev_id, u_long region, u_long block, u_long len,
    u_long, paddr_t addr, u_long *tag);

/* 248 */
int HV_storage_sendcmd(u_long dev_id, u_long cmd, paddr_t pa, u_long len,
    paddr_t data, psize_t datalen, u_long *tag);

/* 249 */
int HV_storage_status(u_long dev_id, u_long *tag, u_long *status);

#define HV_ENOENT -6
#define HV_EBUSY  -9
#define HV_EINVAL -17

#define HV_PAGESIZE_16M	24	/* 16 MB pages */
#define HV_PAGESIZE_4K	12	/*  4 KB pages */
