/*	$Id: ps3.h,v 1.5 2007/04/10 08:04:45 tsubai Exp $	*/

/*-
 * Copyright (c) 2007 Tsubai Masanari.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#define VUART_PARAM_SEND_THRES	0
#define VUART_PARAM_RECV_THRES	1
#define VUART_PARAM_INTR_ENABLE	2
#define VUART_PARAM_RBUFSIZE	3	/* Receive buffer size */
#define VUART_PARAM_RBYTES	4	/* Received bytes in buffer */
#define VUART_PARAM_SBUFSIZE	5	/* Send buffer size */
#define VUART_PARAM_SBYTES	6	/* Bytes to be sent */

#define VUART_INTR_SEND		1
#define VUART_INTR_RECV		2
#define VUART_INTR_DISCONNECT	4

void vuart_init(void);
int vuart_intr_establish(u_int, int (*)(void));
void vuart_enable_irq(u_int, u_long);
int vuart_set_recvsize(u_int, u_long);

void sysmgr_reboot(void);
void sysmgr_shutdown(void);

#define key1(str) \
	str"\0\0\0"[0] << 24 | \
	str"\0\0\0"[1] << 16 | \
	str"\0\0\0"[2] << 8  | \
	str"\0\0\0"[3]

#define key2(str) \
	(long)str"\0\0\0\0\0\0\0"[0] << 56 | \
	(long)str"\0\0\0\0\0\0\0"[1] << 48 | \
	(long)str"\0\0\0\0\0\0\0"[2] << 40 | \
	(long)str"\0\0\0\0\0\0\0"[3] << 32 | \
	(long)str"\0\0\0\0\0\0\0"[4] << 24 | \
	(long)str"\0\0\0\0\0\0\0"[5] << 16 | \
	(long)str"\0\0\0\0\0\0\0"[6] << 8  | \
	(long)str"\0\0\0\0\0\0\0"[7]

int ps3_read_timebase_freq(u_long *);

int ps3_read_bus_id(u_long, u_long *);
int ps3_read_ndev(u_long, u_long *);
int ps3_read_device_id(u_long, u_long, u_long *);
int ps3_read_device_type(u_long, u_long, u_long *);
int ps3_read_interrupt(u_long, u_long, u_long, u_long *, u_long *);
int ps3_read_region_info(u_long, u_long, u_long, u_long *, u_long *, u_long *);

int ps3_read_platform_id(u_long *);
int ps3_read_bus_type(u_long, u_long *);
int ps3_read_pci_bus(u_long, u_long, u_long *);
int ps3_read_pci_device(u_long, u_long, u_long *);
int ps3_read_pci_func(u_long, u_long, u_long *);
