/*	$Id: ps3av.h,v 1.43 2011/11/09 09:01:48 tsubai Exp $	*/

/*-
 * Copyright (c) 2006,2007,2011 Tsubai Masanari.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#define PS3AV_VERSION 0x205

#define PS3AV_CMD_AVPORT_HDMI_0		0x00
#define PS3AV_CMD_AVPORT_HDMI_1		0x01
#define PS3AV_CMD_AVPORT_AVMULTI_0	0x10
#define PS3AV_CMD_AVPORT_SPDIF_0	0x20
#define PS3AV_CMD_AVPORT_SPDIF_1	0x21

#define PS3AV_CMD_VID_480I		1
#define PS3AV_CMD_VID_576I		3
#define PS3AV_CMD_VID_480P		5
#define PS3AV_CMD_VID_576P		6
#define PS3AV_CMD_VID_1080I_60HZ	7
#define PS3AV_CMD_VID_1080I_50HZ	8
#define PS3AV_CMD_VID_720P_60HZ		9
#define PS3AV_CMD_VID_720P_50HZ		10
#define PS3AV_CMD_VID_1080P_60HZ	11
#define PS3AV_CMD_VID_1080P_50HZ	12
#define PS3AV_CMD_VID_1280x768		13
#define PS3AV_CMD_VID_1280x1024		14
#define PS3AV_CMD_VID_1920x1200		15
#define PS3AV_CMD_VID_480I_A		16

#define PS3AV_CMD_EVENT_UNPLUGGED	0x01
#define PS3AV_CMD_EVENT_PLUGGED		0x02
#define PS3AV_CMD_EVENT_HDCP_DONE	0x04
#define PS3AV_CMD_EVENT_HDCP_FAIL	0x08
#define PS3AV_CMD_EVENT_HDCP_REAUTH	0x10
#define PS3AV_CMD_EVENT_HDCP_TOPOLOGY	0x20

#define PS3AV_CMD_MUTE_OFF		0
#define PS3AV_CMD_MUTE_ON		1

#define PS3AV_CMD_AV_VID_480I		0
#define PS3AV_CMD_AV_VID_480P		1
#define PS3AV_CMD_AV_VID_720P_60HZ	2
#define PS3AV_CMD_AV_VID_1080I_60HZ	3
#define PS3AV_CMD_AV_VID_1080P_60HZ	4
#define PS3AV_CMD_AV_VID_576I		5
#define PS3AV_CMD_AV_VID_576P		6
#define PS3AV_CMD_AV_VID_720P_50HZ	7
#define PS3AV_CMD_AV_VID_1080I_50HZ	8
#define PS3AV_CMD_AV_VID_1080P_50HZ	9
#define PS3AV_CMD_AV_VID_1280x768	10
#define PS3AV_CMD_AV_VID_1280x1024	11
#define PS3AV_CMD_AV_VID_1920x1200	12

#define PS3AV_CMD_AV_CS_RGB_8		0
#define PS3AV_CMD_AV_CS_YUV444_8	1
#define PS3AV_CMD_AV_CS_YUV422_8	2
#define PS3AV_CMD_AV_CS_XVYCC_8		3
#define PS3AV_CMD_AV_CS_RGB_10		4
#define PS3AV_CMD_AV_CS_YUV444_10	5
#define PS3AV_CMD_AV_CS_YUV422_10	6
#define PS3AV_CMD_AV_CS_XVYCC_10	7
#define PS3AV_CMD_AV_CS_RGB_12		8
#define PS3AV_CMD_AV_CS_YUV444_12	9
#define PS3AV_CMD_AV_CS_YUV422_12	10
#define PS3AV_CMD_AV_CS_XVYCC_12	11

#define PS3AV_CMD_AV_CS_8		0
#define PS3AV_CMD_AV_CS_10		1
#define PS3AV_CMD_AV_CS_12		2

#define PS3AV_CMD_AV_ASPECT_16_9	0
#define PS3AV_CMD_AV_ASPECT_4_3		1

#define PS3AV_CMD_AV_DITHER_OFF		0x00
#define PS3AV_CMD_AV_DITHER_ON		0x01
#define PS3AV_CMD_AV_DITHER_8BIT	0x00
#define PS3AV_CMD_AV_DITHER_10BIT	0x02
#define PS3AV_CMD_AV_DITHER_12BIT	0x04

#define PS3AV_CMD_HDMI_NORMAL		0xff
#define PS3AV_CMD_HDMI_HDCP_OFF		0x01
#define PS3AV_CMD_HDMI_EDID_PASS	0x80
#define PS3AV_CMD_HDMI_DVI		0x40

#define PS3AV_CMD_CS_RGB_8		1
#define PS3AV_CMD_CS_YUV444_8		2
#define PS3AV_CMD_CS_YUV422_8		3
#define PS3AV_CMD_CS_XVYCC_8		4
#define PS3AV_CMD_CS_RGB_10		5
#define PS3AV_CMD_CS_YUV444_10		6
#define PS3AV_CMD_CS_YUV422_10		7
#define PS3AV_CMD_CS_XVYCC_10		8
#define PS3AV_CMD_CS_RGB_12		9
#define PS3AV_CMD_CS_YUV444_12		10
#define PS3AV_CMD_CS_YUV422_12		11
#define PS3AV_CMD_CS_XVYCC_12		12

#define PS3AV_CMD_VIDEO_OUT_FORMAT_RGB_12BIT 0

#define PS3AV_CMD_VIDEO_FORMAT_BLACK	0
#define PS3AV_CMD_VIDEO_FORMAT_ARGB_8BIT 7

#define PS3AV_CMD_VIDEO_ORDER_RGB	0	/* ARGB */
#define PS3AV_CMD_VIDEO_ORDER_BGR	1	/* ABGR */

#define PS3AV_AVPORT_MAX	(PS3AV_HDMI_MAX + PS3AV_AVMULTI_MAX)
#define PS3AV_HDMI_MAX		2	/* HDMI_0, HDMI_1 */
#define PS3AV_AVMULTI_MAX	1	/* AVMULTI_0 */
#define PS3AV_SPDIF_MAX		1	/* SPDIF_0 */
#define PS3AV_HEAD_MAX		2	/* HEAD_A, HEAD_B */

#define PS3AV_MONITOR_HDMI	1
#define PS3AV_MONITOR_DVI	2

#define PS3AV_REGION_60		0x01
#define PS3AV_REGION_50		0x02
#define PS3AV_REGION_RGB	0x10

#define PS3AV_MODE_MASK		0x000f
#define PS3AV_MODE_HDCP_OFF	0x1000
#define PS3AV_MODE_DITHER	0x0800
#define PS3AV_MODE_DVI		0x0040
#define PS3AV_MODE_RGB		0x0020

#define PS3AV_RESBIT_480P	0x0003
#define PS3AV_RESBIT_576P	0x0003
#define PS3AV_RESBIT_720P	0x0004
#define PS3AV_RESBIT_1080I	0x0008
#define PS3AV_RESBIT_1080P	0x4000
#define PS3AV_RESBIT_MASK_60	(PS3AV_RESBIT_480P | PS3AV_RESBIT_720P | \
				 PS3AV_RESBIT_1080I | PS3AV_RESBIT_1080P)
#define PS3AV_RESBIT_MASK_50	(PS3AV_RESBIT_576P | PS3AV_RESBIT_720P | \
				 PS3AV_RESBIT_1080I | PS3AV_RESBIT_1080P)

struct ps3av_mode_info {
	u_int32_t support;
	u_int32_t native;
} __packed;

struct ps3av_cs_info {
	u_int8_t rgb;
	u_int8_t yuv444;
	u_int8_t yuv422;
	u_int8_t reserved;
} __packed;

struct ps3av_color_info {
	u_int16_t red_x;
	u_int16_t red_y;
	u_int16_t green_x;
	u_int16_t green_y;
	u_int16_t blue_x;
	u_int16_t blue_y;
	u_int16_t white_x;
	u_int16_t white_y;
	u_int32_t gamma;
} __packed;

struct ps3av_monitor_info {
	u_int8_t avport;
	u_int16_t vendor_id;
	u_int16_t product_id;
	u_int32_t serial;
	u_int8_t week;
	u_int8_t year;
	u_int8_t monitor_type;
	char monitor_name[16];
	struct ps3av_mode_info mode_60;
	struct ps3av_mode_info mode_50;
	struct ps3av_mode_info mode_other;
	struct ps3av_mode_info mode_vesa;
	struct ps3av_cs_info cs;
	struct ps3av_color_info color;
	u_int8_t supported_ai;
	u_int8_t speaker_info;
	u_int8_t n_audio_block;
} __packed;

struct ps3av_audio_info {
	u_int8_t type;
	u_int8_t maxch;
	u_int8_t fs;
	u_int8_t sbit;
} __packed;

int ps3av_cmd_init(void);
int ps3av_cmd_fin(void);
int ps3av_cmd_get_hwconf(int *, int *, int *);
int ps3av_cmd_get_monitor_info(u_int, void *, u_int);
int ps3av_cmd_enable_event(u_int);
int ps3av_cmd_disable_event(u_int);
int ps3av_cmd_av_tv_mute(u_int, u_int);
int ps3av_cmd_av_video_mute(u_int, u_int);
int ps3av_cmd_av_video_signal_off(u_int);
int ps3av_cmd_av_hdmi_mode(u_int);
int ps3av_cmd_av_video_cs(u_int, int, int, int, u_int);
int ps3av_cmd_video_mode(int, int);
int ps3av_cmd_video_format(u_int, u_int, u_int);
int ps3av_cmd_video_stride(u_int, u_int);
int ps3av_cmd_av_audio_mute(u_int, u_int);
int ps3av_cmd_audio_mute(u_int, u_int);
int ps3av_cmd_audio_active(int, u_int);

void ps3av_dump_monitor_info(void *);
void ps3av_vuart_init(void);

int ps3av_set_video_mode(int);
int ps3av_get_video_mode(void);
int ps3av_screen_size(u_int, u_int *, u_int *);
int ps3av_video_signal_off(void);
int ps3av_video_mute(int);
int ps3av_audio_mute(int);

int ps3av_init(void);
