/*	$Id: rsxfbio.h,v 1.6 2011/11/03 00:59:01 tsubai Exp $	*/

/*-
 * Copyright (c) 2007 Tsubai Masanari.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef _MACHINE_RSXFBIO_H_
#define _MACHINE_RSXFBIO_H_

#define RSXFBIOCGMODE	_IOR('F', 0, int)		/* Get mode */
#define RSXFBIOCSMODE	_IOW('F', 1, int)		/* Set mode */

struct rsxfbparam {
	off_t vram;
	off_t fifo;
	off_t fiforeg;
	off_t notifier;
	int vram_size;
	int fifo_size;
	int fiforeg_size;
	int notifier_size;
	u_int fifo_gpu;
};
#define RSXFBIOCGPARAM	_IOR('F', 2, struct rsxfbparam)

struct blit_param {
	u_int64_t param1;
	u_int64_t param2;
	u_int64_t param3;
	u_int64_t param4;
	u_int64_t param5;
};
#define RSXFBIOCBLIT	_IOW('F', 100, struct blit_param) /* BLIT test */

#endif /* _MACHINE_RSXFBIO_H_ */
