/*	$Id: hcalls.S,v 1.30 2011/10/26 11:55:17 tsubai Exp $	*/

/*-
 * Copyright (c) 2006,2007 Tsubai Masanari.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <machine/asm.h>

#define hcall .long 0x44000022

lv1_0_in_0_out:
lv1_1_in_0_out:
lv1_2_in_0_out:
lv1_3_in_0_out:
lv1_4_in_0_out:
lv1_5_in_0_out:
lv1_6_in_0_out:
lv1_7_in_0_out:
	mflr	0
	std	0,16(1)
	hcall
	extsw	3,3
	ld	0,16(1)
	mtlr	0
	blr

/* Assume parameter save area (sp+48) is unchanged during hcall. */
#define lv1_n_in_1_out(n)	 \
	mflr	0		;\
	std	0,16(1)		;\
	std	3+n,48(1)	;\
	hcall			;\
	extsw	3,3		;\
	ld	11,48(1)	;\
	std	4,0(11)		;\
	ld	0,16(1)		;\
	mtlr	0		;\
	blr

lv1_0_in_1_out: lv1_n_in_1_out(0)
lv1_1_in_1_out: lv1_n_in_1_out(1)
lv1_2_in_1_out: lv1_n_in_1_out(2)
lv1_3_in_1_out: lv1_n_in_1_out(3)
lv1_4_in_1_out: lv1_n_in_1_out(4)
lv1_5_in_1_out: lv1_n_in_1_out(5)
lv1_6_in_1_out: lv1_n_in_1_out(6)

#define lv1_n_in_2_out(n)	 \
	mflr	0		;\
	std	0,16(1)		;\
	std	3+n,48(1)	;\
	std	4+n,56(1)	;\
	hcall			;\
	extsw	3,3		;\
	ld	11,48(1)	;\
	std	4,0(11)		;\
	ld	11,56(1)	;\
	std	5,0(11)		;\
	ld	0,16(1)		;\
	mtlr	0		;\
	blr

lv1_0_in_2_out: lv1_n_in_2_out(0)
lv1_1_in_2_out: lv1_n_in_2_out(1)
lv1_3_in_2_out: lv1_n_in_2_out(3)
lv1_4_in_2_out: lv1_n_in_2_out(4)
lv1_5_in_2_out: lv1_n_in_2_out(5)
lv1_6_in_2_out: lv1_n_in_2_out(6)

lv1_6_in_3_out:
	mflr	0
	std	0,16(1)
	std	9,48(1)
	std	10,56(1)
	hcall
	extsw	3,3
	ld	11,48(1)
	std	4,0(11)
	ld	11,56(1)
	std	5,0(11)
	ld	11,112(1)
	std	6,0(11)
	ld	0,16(1)
	mtlr	0
	blr

#define lv1_n_in_4_out(n)	 \
	mflr	0		;\
	std	0,16(1)		;\
	std	3+n,48(1)	;\
	std	4+n,56(1)	;\
	std	5+n,64(1)	;\
	std	6+n,72(1)	;\
	hcall			;\
	extsw	3,3		;\
	ld	11,48(1)	;\
	std	4,0(11)		;\
	ld	11,56(1)	;\
	std	5,0(11)		;\
	ld	11,64(1)	;\
	std	6,0(11)		;\
	ld	11,72(1)	;\
	std	7,0(11)		;\
	ld	0,16(1)		;\
	mtlr	0		;\
	blr

lv1_1_in_4_out: lv1_n_in_4_out(1)

#define lv1_n_in_5_out(n)	 \
	mflr	0		;\
	std	0,16(1)		;\
	std	3+n,48(1)	;\
	std	4+n,56(1)	;\
	std	5+n,64(1)	;\
	std	6+n,72(1)	;\
	std	7+n,80(1)	;\
	hcall			;\
	extsw	3,3		;\
	ld	11,48(1)	;\
	std	4,0(11)		;\
	ld	11,56(1)	;\
	std	5,0(11)		;\
	ld	11,64(1)	;\
	std	6,0(11)		;\
	ld	11,72(1)	;\
	std	7,0(11)		;\
	ld	11,80(1)	;\
	std	8,0(11)		;\
	ld	0,16(1)		;\
	mtlr	0		;\
	blr

lv1_1_in_5_out: lv1_n_in_5_out(1)
lv1_2_in_5_out: lv1_n_in_5_out(2)

lv1_7_in_6_out:
	mflr	0
	std	0,16(1)
	std	10,48(1)
	hcall
	extsw	3,3
	ld	11,48(1)
	std	4,0(11)
	ld	11,112(1)
	std	5,0(11)
	ld	11,120(1)
	std	6,0(11)
	ld	11,128(1)
	std	7,0(11)
	ld	11,136(1)
	std	8,0(11)
	ld	11,144(1)
	std	9,0(11)
	ld	0,16(1)
	mtlr	0
	blr

#if 0

HV_alloc_device_dma_region(bus_id, dev_id, len, pagesize, flags, &dma);
iommuѤvaݤ롢ΤȻפ
len: ΰĹ
pagesize: ڡĹ (log2)
flags = 2  8bit ⡼ 餷


HV_map_device_dma_region(bus_id, dev_id, pa, dma_addr, size, flags);
iommuꤹ롣
pa  size ĹΥ꡼򡢥ǥХ鸫 dma_addr ˥ޥåפ롣
pa  LPAR ǤΥɥ쥹
flags ϰ̣ (0xf800.0000.0000.0000)


HV_alloc_memory(size, 1, 2, flags, &addr, &muid);
꡼ݤ롣
1 = 24	/* 2^24 = 16MB */
2 = 0
flags ˤ LV1_AM_* ꤹ餷
addr ɥ쥹
muid 


HV_construct_virtual_address_space(min_htab_size, n_page_sizes, page_sizes,
    &vas_id, &actual_size);
min_htab_size ϥåɽκǾ͡1MB餷
page_sizes: ӥå[0-7][8-15][16-23][24-31]ˤ줾ѤڡĹ
	񤯤餷
	16: 64KB
	20: 1MB
	24: 16MB
n_page_sizes: page_sizes ο
vas_id: HV_select_virtual_address_space Ϳ͡
actual_size: ϥåɽ礭


HV_select_virtual_address_space(vas_id)
̣mtsdr1 ?


HV_shutdown_lpa(mode)
֡ȡ
(gelic  DMA ߤƤʤ¿)

mode = 1 : HALT (äƤɤʤ?)
     = 2 : Ÿ
     = 3 : Ƶư


HV_gpu_context_iomap(handle, dmabase, physaddr, size, 0);

IOMMU ꡣ
絭 physaddr  size ΰ褬GPU ¦鸫 dmabase ʹߤ
褦ˤʤ롣1MB ׵᤹롣

handle: context handle
dmabase: IOMMU ɥɥ쥹
physaddr: 絭¦ʪɥ쥹
size: Ĺ


HV_gpu_context_attribute(handle, GPU_FB_SETUP, physaddr, size, dma_addr, N/U)

GPU FIFO ꡣ
絭 physaddr  4KB ΰ褬Ȥ봶
GPU 鸫ɥ쥹 dma_addr
physaddr  dma_addr бƤʤȤʤѡ1MB ɬ?
ºݤˤ 8KB Ǥ⤤ߤ
FIFO ȸʤƬȤΤ size Τɤ狼ʤ:-)

handle: context handle
physaddr: ʪɥ쥹
size: FIFO Ĺʤ
dma_addr: IOMMU ɥ쥹 -- 0x0d000000 + offset ߤʡ


HV_gpu_context_attribute(handle, GPU_FB_BLIT,
    offset, dma_addr, sync << 32 | width << 16 | height, stride)
絭VRAMؤΥԡ

handle: context handle
offset: ž VRAM Υեåȡ64 ХȶǤ뤳ȡ
dma_addr: 絭¦(ž) IOMMU ɥ쥹 -- 0x0d000000 Υɥ
width, height: ΰ礭
stride: VRAM


HV_gpu_context_attribute(handle, GPU_DISPLAY_FLIP, head, offset, N/U, N/U);
ɽ֤λꡣ

handle: context handle
head: head 0  head 1
offset: VRAMɽϥɥ쥹եåȡ


#endif

FDESC(HV_write_pte)
ENTRY(HV_write_pte)
	li	11,1
	b	lv1_4_in_0_out

FDESC(HV_construct_virtual_address_space)
ENTRY(HV_construct_virtual_address_space)
	li	11,2
	b	lv1_3_in_2_out

FDESC(HV_select_virtual_address_space)
ENTRY(HV_select_virtual_address_space)
	li	11,7
	b	lv1_1_in_0_out

FDESC(HV_pause)
ENTRY(HV_pause)
	li	11,9
	b	lv1_1_in_0_out

FDESC(HV_configure_irq_bitmap)
ENTRY(HV_configure_irq_bitmap)
	li	11,11
	b	lv1_3_in_0_out

/* lv1_construct_event_receive_port(&outlet_id) */
FDESC(HV_alloc_intrhand)
ENTRY(HV_alloc_intrhand)
	li	11,18
	b	lv1_0_in_1_out

FDESC(HV_eoi)
ENTRY(HV_eoi)
	li	11,27
	b	lv1_1_in_0_out

/* lv1_construct_and_connect_irq_plug(irq, outlet_id) */
FDESC(HV_set_intrhand_irq)
ENTRY(HV_set_intrhand_irq)
	li	11,28
	b	lv1_2_in_0_out

FDESC(HV_notify_imask_change)
ENTRY(HV_notify_imask_change)
	li	11,31
	b	lv1_2_in_0_out

FDESC(HV_shutdown_lpar)
ENTRY(HV_shutdown_lpar)
	li	11,44
	b	lv1_1_in_0_out

FDESC(HV_get_pu_id)
ENTRY(HV_get_pu_id)
	li	11,69
	b	lv1_0_in_1_out

FDESC(HV_get_lpar_id)
ENTRY(HV_get_lpar_id)
	li	11,74
	b	lv1_0_in_1_out

#define HV_n_in_2_out(n)	 \
	mflr	0		;\
	std	0,16(1)		;\
	std	3+n,48(1)	;\
	hcall			;\
	extsw	3,3		;\
	ld	0,16(1)		;\
	mtlr	0		;\
	ld	11,48(1)	;\
	std	4,0(11)		;\
	std	5,8(11)		;\
	blr

FDESC(HV_read_repository)
ENTRY(HV_read_repository)
	li	11,91
	b	HV_5_in_2_out

HV_5_in_2_out: HV_n_in_2_out(5)

/* lv1_construct_io_irq_outlet(irq, &outlet_id) */
FDESC(HV_alloc_intrhand_by_irq)
ENTRY(HV_alloc_intrhand_by_irq)
	li	11,120
	b	lv1_1_in_1_out

FDESC(HV_map_htab)
ENTRY(HV_map_htab)
	li	11,122
	b	lv1_1_in_1_out

FDESC(HV_open)
ENTRY(HV_open)
	li	11,170
	b	lv1_3_in_0_out

FDESC(HV_close)
ENTRY(HV_close)
	li	11,171
	b	lv1_2_in_0_out

FDESC(HV_map_device_mmio_region)
ENTRY(HV_map_device_mmio_region)
	li	11,172
	b	lv1_5_in_1_out

FDESC(HV_alloc_device_dma_region)
ENTRY(HV_alloc_device_dma_region)
	li	11,174
	b	lv1_5_in_1_out

FDESC(HV_map_device_dma_region)
ENTRY(HV_map_device_dma_region)
	li	11,176
	b	lv1_6_in_0_out

/* lv1_connect_interrupt_event_receive_port() */
FDESC(HV_set_device_intrhand)
ENTRY(HV_set_device_intrhand)
	li	11,197
	b	lv1_4_in_0_out

FDESC(HV_read_rtc)
ENTRY(HV_read_rtc)
	li	11,232
	b	lv1_0_in_2_out

FDESC(HV_read_vuart)
ENTRY(HV_read_vuart)
	li	11,162
	b	lv1_3_in_1_out

FDESC(HV_write_vuart)
ENTRY(HV_write_vuart)
	li	11,163
	b	lv1_3_in_1_out

FDESC(HV_set_vuart_param)
ENTRY(HV_set_vuart_param)
	li	11,164
	b	lv1_3_in_0_out

FDESC(HV_get_vuart_param)
ENTRY(HV_get_vuart_param)
	li	11,165
	b	lv1_2_in_1_out

FDESC(HV_configure_vuart)
ENTRY(HV_configure_vuart)
	li	11,166
	b	lv1_1_in_1_out

FDESC(HV_net_add_mcast)
ENTRY(HV_net_add_mcast)
	li	11,185
	b	lv1_4_in_0_out

FDESC(HV_net_del_mcast)
ENTRY(HV_net_del_mcast)
	li	11,186
	b	lv1_4_in_0_out

FDESC(HV_net_start_txdma)
ENTRY(HV_net_start_txdma)
	li	11,187
	b	lv1_4_in_0_out

FDESC(HV_net_stop_txdma)
ENTRY(HV_net_stop_txdma)
	li	11,188
	b	lv1_3_in_0_out

FDESC(HV_net_start_rxdma)
ENTRY(HV_net_start_rxdma)
	li	11,189
	b	lv1_4_in_0_out

FDESC(HV_net_stop_rxdma)
ENTRY(HV_net_stop_rxdma)
	li	11,190
	b	lv1_3_in_0_out

FDESC(HV_net_set_intrstatus_indicator)
ENTRY(HV_net_set_intrstatus_indicator)
	li	11,191
	b	lv1_4_in_0_out

FDESC(HV_net_set_intrmask)
ENTRY(HV_net_set_intrmask)
	li	11,193
	b	lv1_4_in_0_out

FDESC(HV_net_control)
ENTRY(HV_net_control)
	li	11,194
	b	lv1_6_in_2_out

FDESC(HV_gpu_open)
ENTRY(HV_gpu_open)
	li	11,210
	b	lv1_1_in_0_out

FDESC(HV_gpu_alloc_memory)
ENTRY(HV_gpu_alloc_memory)
	li	11,214
	b	lv1_5_in_2_out

FDESC(HV_gpu_alloc_context)
ENTRY(HV_gpu_alloc_context)
	li	11,217
	b	lv1_2_in_5_out

FDESC(HV_gpu_context_iomap)
ENTRY(HV_gpu_context_iomap)
	li	11,221
	b	lv1_5_in_0_out

FDESC(HV_gpu_context_attribute)
ENTRY(HV_gpu_context_attribute)
	li	11,225
	b	lv1_6_in_0_out

FDESC(HV_storage_read)
ENTRY(HV_storage_read)
	li	11,245
	b	lv1_6_in_1_out

FDESC(HV_storage_write)
ENTRY(HV_storage_write)
	li	11,246
	b	lv1_6_in_1_out

FDESC(HV_storage_sendcmd)
ENTRY(HV_storage_sendcmd)
	li	11,248
	b	lv1_6_in_1_out

FDESC(HV_storage_status)
ENTRY(HV_storage_status)
	li	11,249
	b	lv1_1_in_2_out
