/*	$Id: locore.S,v 1.26 2011/11/09 09:47:01 tsubai Exp $	*/

/*
 * Copyright (C) 1995, 1996 Wolfgang Solfrank.
 * Copyright (C) 1995, 1996 TooLs GmbH.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by TooLs GmbH.
 * 4. The name of TooLs GmbH may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY TOOLS GMBH ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL TOOLS GMBH BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "opt_ddb.h"
#include "opt_modular.h"
#include "opt_multiprocessor.h"
#include "assym.h"
#include "ksyms.h"

#include <machine/param.h>
#include <machine/psl.h>
#include <machine/asm.h>

#define CTRL	136
#define CTRL_W	152
#define PIR	1023

/*
 * Globals
 */
	.data
GLOBAL(esym)
	.long	0			/* end of symbol table */

	.globl	intrnames,eintrnames
intrnames:
	.asciz	"irq0", "irq1", "irq2", "irq3"
	.asciz	"irq4", "irq5", "irq6", "irq7"
	.asciz	"irq8", "irq9", "irq10", "irq11"
	.asciz	"irq12", "irq13", "irq14", "irq15"
	.asciz	"irq16", "irq17", "irq18", "irq19"
	.asciz	"irq20", "irq21", "irq22", "irq23"
	.asciz	"irq24", "irq25", "irq26", "irq27"
	.asciz	"irq28", "irq29", "irq30", "irq31"
	.asciz	"irq32", "irq33", "irq34", "irq35"
	.asciz	"irq36", "irq37", "irq38", "irq39"
	.asciz	"irq40", "irq41", "irq42", "irq43"
	.asciz	"irq44", "irq45", "irq46", "irq47"
	.asciz	"irq48", "irq49", "irq50", "irq51"
	.asciz	"irq52", "irq53", "irq54", "irq55"
	.asciz	"irq56", "irq57", "irq58"
	.asciz	"clock", "softclock", "softbio", "softnet", "softserial"
eintrnames:

	.align	4
	.globl	intrcnt,eintrcnt
intrcnt:
	.llong	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.llong	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.llong	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.llong	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
eintrcnt:

/*
 * File-scope for locore.S
 */
	.data
magic:	.llong	0x4e65744253440000

/*
 * This symbol is here for the benefit of kvm_mkdb, and is supposed to
 * mark the start of kernel text.
 */
	.section .init
	.globl	_C_LABEL(kernel_text)
_C_LABEL(kernel_text):
	b	__start
	     nop; nop; nop; nop; nop; nop; nop;
	nop; nop; nop; nop; nop; nop; nop; nop;
	nop; nop; nop; nop; nop; nop; nop; nop;
	nop; nop; nop; nop; nop; nop; nop; nop;
	nop; nop; nop; nop; nop; nop; nop; nop;
	nop; nop; nop; nop; nop; nop; nop; nop;
	nop; nop; nop; nop; nop; nop; nop; nop;

	/* Entry point of secondary thread */
secondary_entry:
	li	0,0
	mtmsrd	0
	isync
2:	lwz	0,0x20(0)
	cmpwi	0,1
	bne	2b
	ba	secondary_halt
	nop

/*
 * Startup entry.  Note, this must be the first thing in the text
 * segment!
 */
	.text
	.globl	__start
__start:
	/* Stop thread 1 */
	mfspr	31,PIR
	andi.	31,31,1
	bne	secondary_entry

	lis	31,magic@ha
	ld	30,magic@l(31)
	cmpd	3,30
	bne	relocate_self

normal_entry:
	mr	6,4			/* ssym */
	mr	7,5			/* esym */
	mr	5,3			/* magic */

/* compute end of kernel memory */
	lis	8,end@ha
	addi	8,8,end@l
#if NKSYMS || defined(DDB) || defined(MODULAR)
	cmpwi	7,0
	beq	1f
	mr	8,7
1:
#endif

	li	9,PGOFSET
	add	8,8,9
	andc	8,8,9
	lis	9,cpu_info@ha
	addi	9,9,cpu_info@l

	addi	8,8,INTSTK
	std	8,CI_INTSTK(9)
#ifdef DDB
	addi	8,8,DDBSTK
	std	8,CI_DDBSTK(9)
#endif
	addi	8,8,SPILLSTK
	std	8,CI_SPILLSTK(9)
	lis	9,proc0paddr@ha
	std	8,proc0paddr@l(9)
	addi	1,8,USPACE-FRAMELEN	/* stackpointer for proc0 */
	mr	4,1			/* end of mem reserved for kernel */
	li	0,0
	stdu	0,-128(1)		/* end of stack chain */

	lis	3,tocbase@ha
	ld	2,tocbase@l(3)
	lis	3,__start@ha
	addi	3,3,__start@l
	bl	_C_LABEL(initppc)
	nop
	bl	_C_LABEL(main)
	nop
	bl	_C_LABEL(ppc_exit)
	nop
	b	.			/* for (;;) */

	.align	3
tocbase:
	.llong	.TOC.@tocbase


relocate_self:
	/* Relocate myself. */
	bl	3f
3:	mflr	14
	subi	14,14,(3b - __start)	/* r14 = load address */

	lis	15,__start@ha
	addi	15,15,__start@l
	lis	16,_edata@ha
	addi	16,16,_edata@l

	mr	3,14
	mr	4,15			/* __start */
1:	ld	0,0(3)
	std	0,0(4)

	dcbst	0,4			/* syncicache() */
	sync
	icbi	0,4
	sync
	isync

	addi	3,3,8
	addi	4,4,8
	cmpld	4,16			/* _edata */
	blt	1b

	mr	4,16			/* _edata */
	lis	17,_end@ha
	addi	17,17,_end@l
	li	0,0
1:	std	0,0(4)
	addi	4,4,8
	cmpld	4,17
	blt	1b

	li	3,0
	li	4,0
	li	5,0
	ba	normal_entry


	.lcomm	haltstk,256,16
secondary_halt:
	li	0,0
	stw	0,0x20(0)
	sync
	mtmsrd	0
	isync

1:	lis	3,0x7fff
	mtdec	3
	or	1,1,1		/* Change current thread priority to low */
	or	28,28,28
	lis	1,haltstk+128@ha
	addi	1,1,haltstk+128@l
	li	3,0
	bl	.HV_pause

	b	1b

/*
 * kboot¹Ԥ:
 * ͥϥʥɥ쥹˥ɤơth0ϤƬ֡
 * ͥƬ256ХȤɥ쥹0˥ԡ졢th1Ϥ¹Ԥ롣
 *
 * եå夫¹Ԥ:
 * ͥϥɥ쥹0˥ɤơth0/th1ξƬ֡
 */
