/*	$Id: start.S,v 1.12 2009/07/04 14:38:31 tsubai Exp $	*/

/*-
 * Copyright (c) 2007 Tsubai Masanari.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <machine/asm.h>
#include <machine/spr.h>

#define STACKSIZE 16384
	.lcomm	stack,STACKSIZE,256

	.text
	.globl	_start

_start:
	b	1f
	.space	252

1:	li	0,0
	mtmsr	0
	lis	3,0x7fff
	mtdec	3
	isync

	mfspr	3,PIR
	andi.	3,3,1
	bne	secondary_entry		/* idle secondary thread */

	lis	1,stack+STACKSIZE@ha
	addi	1,1,stack+STACKSIZE@l
	li	0,0
	stdu	0,-128(1)		/* end of stack chain */

	lis	3,_C_LABEL(main)@ha	/* FDESC */
	addi	3,3,_C_LABEL(main)@l
	ld	2,8(3)

	lis	3,_C_LABEL(_rtt)@ha
	ld	3,_C_LABEL(_rtt)@l(3)
	oris	3,3,0x4800
	ori	3,3,0x0002		/* ba _rtt */
	stw	3,0(0)

	bl	_C_LABEL(main)
	bl	_C_LABEL(_rtt)


	/* Entry point of secondary thread */
secondary_entry:
	lis	3,0x7fff
	mtdec	3
	or	1,1,1		/* Change current thread priority to low */
	lis	3,entry2@ha
	ld	4,entry2@l(3)
	cmpdi	4,0
	beq	secondary_entry

	mtctr	4
	bctr

/*	.space	0x8000	*/

	.data
	.globl	entry2
entry2:
	.llong	0
